var http = require('http');
var fs = require("fs");
var path = require('path');
var saveDir = '/temp/';//保存在U盘地址的目录路径(注意需要完整路径)
var camIP = 'localhost';//摄像头的ip地址
var camPort = 8080;//mjpg_streamer的端口
var sleepTime = 5*60*1000;//5分钟保存一次

startwork();//开始程序入口

//休眠函数
function sleep(milliSeconds) { 
	var startTime = new Date().getTime(); 
	while (new Date().getTime() < startTime + milliSeconds);
};

//工作函数
function startwork(callback){
	console.log("start to save work at:"+ new Date());
	downpic(camIP,camPort,function(imgpath){
		if(imgpath) console.log('save work done');
		sleep(sleepTime);
		startwork();
	});
}

//下载图片函数
function downpic(host,port,callback){
	try{
		var localpath = saveDir;
		if(!fs.existsSync(localpath)){
			fs.mkdirSync(localpath);
		}
		var imgpath = new Date().getTime().toString()+'.jpg';
		var picReq = http.request({
		    hostname: host,
		    port: port,
		    path: '/?action=snapshot',
		    method: 'GET'
		}, function(picRes){
			var picpath = path.join(localpath, imgpath);
			var picstream = fs.createWriteStream(picpath,{
				flags: 'a',
				encoding: null,
				mode: 0666   
			});
	        picstream.on('close', function(){
	            callback(imgpath);
	        });
	        picRes.pipe(picstream);
		});
		picReq.on('error', function(e){
			console.log('pic with request: ' + e.message);
			callback('');
		});
		picReq.end();
	}catch(e){
		console.log('catch error: ' + e.message);
		callback('');
	}
}